﻿
Imports Microsoft.AnalysisServices.AdomdClient

Module DataMining
    Sub Main()
        Dim conn As New AdomdConnection
        Try
            Dim model As MiningModel

            Dim col As MiningModelColumn
            conn.ConnectionString = "Data Source=local;Provider=MSOLAP;Catalog=Adventure Works DW 2008 SE"
            conn.Open()
            For Each model In conn.MiningModels
                Console.WriteLine("Name: " + model.Name)
                Console.WriteLine("Algorithmus: " + model.Algorithm)
                Console.WriteLine("Eigenschaften:")
                For Each p In model.Properties
                    If Not p.Value Is Nothing Then
                        Console.WriteLine(vbTab + p.Name + "  Wert: " + p.Value.ToString)
                    End If
                Next
                Console.WriteLine("Spalten:")
                For Each col In model.Columns
                    Console.WriteLine(vbTab + col.Name)
                    If col.IsInput Then
                        Console.WriteLine(vbTab + vbTab + "Eingabespalte")
                    End If
                    If col.IsPredictable Then
                        Console.WriteLine(vbTab + vbTab + "Vorhersagespalte")
                    End If
                    Console.WriteLine(vbTab + vbTab + "Typ: " + col.Type.ToString)
                Next
            Next
            conn.Close()
            Console.ReadLine()
        Catch err As Exception
            Console.WriteLine(err.Message)
        Finally
            conn.Close(False)
        End Try
        Console.ReadLine()
    End Sub
End Module
