﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;
using System.Data;

namespace DatenAbrufen
{
    class DatenAbrufen
    {
        static void Main(string[] args)
        {
            AdomdConnection conn = new AdomdConnection();
            try
            {
                conn.ConnectionString = "Data Source=local;Catalog= Adventure Works DW 2008 SE";
                conn.Open();
                datareader(conn);
                xmla(conn);
                cellsetMetaDatenAbfrage(conn);
                cellsetMetaDatenErgebnis(conn);
                cellsetDaten(conn);

            }

            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            finally
            {
                if (conn.State == System.Data.ConnectionState.Open)
                {
                    conn.Close();
                }
            }
            Console.ReadLine();
        }
    static void datareader(AdomdConnection conn)
    {


 AdomdCommand cmd = conn.CreateCommand();
 cmd.CommandText = " SELECT {[Product].[Color].[Black],[Product].[Color].[Blue]} on 0,"
                   +"         [Customer].[Gender].Children on 1  "
                   + "  FROM [Adventure Works]   WHERE [Measures].[Internet Sales Amount]";
 AdomdDataReader dreader = cmd.ExecuteReader();
 DataTable metaTable = dreader.GetSchemaTable();
 foreach (DataRow metaRow in metaTable.Rows)
 {
     Console.WriteLine(metaRow["ColumnName"]);
 }
 Console.WriteLine();
 while(dreader.Read()){
     for (int i = 0; i<dreader.FieldCount; i++)
     {
        if (dreader.IsDBNull(i))
        {
            Console.WriteLine("NULL ");
        }
        else
        {
           Console.WriteLine(dreader.GetString(i));
        }
      }
  
   }
dreader.Close();


    }
        static void xmla(AdomdConnection conn)
        {
 
            AdomdCommand cmd = conn.CreateCommand();
            cmd.CommandText = " SELECT [Product].[Color].members on 0,{[Customer].[Gender].&F,"
                               + " [Customer].[Gender].&[M]} on 1 FROM [Adventure Works] ";
            System.Xml.XmlReader xreader = cmd.ExecuteXmlReader();
            // XML Auswerten
            System.Xml.XmlDocument doc = new System.Xml.XmlDocument();
            doc.Load(xreader);
            doc.Save("c:\\temp\\xmlReader.xml");
            //xwriter.c

            
            
            xreader.Close();
            //conn.Close();


        }
static void cellsetMetaDatenAbfrage(AdomdConnection conn)
{

AdomdCommand cmd = conn.CreateCommand();
cmd.CommandText = @"SELECT {[Product].[Color].Multi:[Product].[Color].Silver} on 0,
          {([Customer].[Gender].&[F],[Customer].[Occupation].&[Clerical]), 
               ([Customer].[Gender].&[M],[Customer].[Occupation].&[Professional])} on 1,
          {[Customer].[Marital Status].&[M],[Customer].[Marital Status].&[S]}on 2
   FROM [Adventure Works] Where [Measures].[Internet Sales Amount]";
CellSet ces = cmd.ExecuteCellSet();

foreach (OlapInfoCube infoCube in ces.OlapInfo.CubeInfo.Cubes)
{
    Console.WriteLine("Abgefragte Cubes: " + infoCube.CubeName);
    Console.WriteLine("\tletztes Update: " + infoCube.LastDataUpdate);
}
foreach (OlapInfoAxis infoAxis in ces.OlapInfo.AxesInfo.Axes)
{
    Console.WriteLine("Abgefragte Achsen: " + infoAxis.Name);
    foreach (OlapInfoHierarchy infoHierachy in infoAxis.Hierarchies)
    {
        Console.WriteLine("\tenthaltene Hierachie: " + infoHierachy.Name);
        foreach(OlapInfoProperty infoProp in infoHierachy.HierarchyProperties){
            Console.WriteLine("\t\tEigenschaft: "+ infoProp.Name );
        }
    }
}
//Console.WriteLine("Filter Achse: " + ces.OlapInfo.AxesInfo.FilterAxis.Name);
//foreach (OlapInfoHierarchy infoHierachy in ces.OlapInfo.AxesInfo.FilterAxis.Hierarchies)
//{
//    Console.WriteLine("\tenthaltene Hierachie: " + infoHierachy.Name);
//    foreach (OlapInfoProperty infoProp in infoHierachy.HierarchyProperties)
//    {
//        Console.WriteLine("\t\tEigenschaft: " + infoProp.Name);
//    }
//}

foreach (OlapInfoProperty infoProp in ces.OlapInfo.CellInfo.CellProperties)
{
    Console.WriteLine("enthaltene Zelleigenschaften: " + infoProp.Name);
}
}
static void cellsetMetaDatenErgebnis(AdomdConnection conn)
{

AdomdCommand cmd = conn.CreateCommand();
cmd.CommandText = @"SELECT {[Product].[Color].Multi:[Product].[Color].Silver} on 0,
                  {([Customer].[Gender].&[F],[Customer].[Occupation].&[Clerical]), 
                       ([Customer].[Gender].&[M],[Customer].[Occupation].&[Professional])} on 1,
                  {[Customer].[Marital Status].&[M],[Customer].[Marital Status].&[S]}on 2
           FROM [Adventure Works] Where [Measures].[Internet Sales Amount]";
CellSet ces = cmd.ExecuteCellSet();

Console.WriteLine("Filter Achse: " + ces.FilterAxis.Name);
List<String> defaultMembers=new List<String>();
foreach(Hierarchy h in ces.FilterAxis.Set.Hierarchies){
    defaultMembers.Add(h.DefaultMember);//uniqueName
}
foreach (Tuple tup in ces.FilterAxis.Set.Tuples)
{
    Console.WriteLine("\tTupel: " + tup.TupleOrdinal);
    foreach (Member el in tup.Members)
    {
        if(!defaultMembers.Contains(el.UniqueName)){
            Console.WriteLine("\t\tElement: " + el.Caption);
        }
    }
}
foreach (Axis ax in ces.Axes)
{
    Console.WriteLine("Achse: " + ax.Name);
    Console.WriteLine("\tAbgefragte Tuple");
    foreach (Tuple tup in ax.Set.Tuples)
    {
        Console.WriteLine("\tTupel: " + tup.TupleOrdinal);
        foreach (Member el in tup.Members)
        {
            Console.WriteLine("\t\tElement: " + el.Caption);
        }
    }

    Console.WriteLine("\n\n\tHierarchien, die in der Ergebnismenge vorkommen:");
    foreach (Hierarchy hy in ax.Set.Hierarchies)
    {
        Console.WriteLine("\t" + hy.Name);
        foreach (Level lev in hy.Levels)
        {
            Console.WriteLine("\t\tenthaltene Ebenen: " + lev.Caption);
            foreach (Member el in lev.GetMembers())
            {
                Console.WriteLine("\t\t\tElement: " + el.Caption);
            }
        }
    }
}
}
static void cellsetDaten(AdomdConnection conn)
{

AdomdCommand cmd = conn.CreateCommand();
cmd.CommandText = @"SELECT {[Product].[Color].Multi:[Product].[Color].Silver} on 0,
                          {([Customer].[Gender].&[F],[Customer].[Occupation].&[Clerical]), 
                             ([Customer].[Gender].&[M],[Customer].[Occupation].&[Professional])} on 1,
                          {[Customer].[Marital Status].&[M],[Customer].[Marital Status].&[S]}on 2
                 FROM [Adventure Works] Where [Measures].[Internet Sales Amount]";

CellSet ces = cmd.ExecuteCellSet();
for (int z = 0; z < ces.Axes[2].Set.Tuples.Count; z++)
{
    Console.WriteLine("Seite: " + z);
    for (int y = 0; y < ces.Axes[1].Set.Tuples.Count; y++)
    {
        Console.WriteLine("\tZeile: " + y);
        for (int x = 0; x < ces.Axes[0].Set.Tuples.Count; x++)
        {
            Console.WriteLine("\t\tSpalte: " + x + " Wert: " + ces.Cells[x, y, z].Value);
        }
    }
}
}
}
}
