﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.AnalysisServices.AdomdClient;


namespace DirekterZugriff
{
    class MetadatenAusgabe
    {
        static void Main(string[] args)
        {
            AdomdConnection conn = new AdomdConnection();
            try
            {

                conn.ConnectionString = "Data Source=local;Catalog= Adventure Works DW 2008 SE";
                conn.Open();

                //CubeDef cdef=conn.Cubes[1];
                //Dimension d=cdef.Dimensions["Customer"];
                //Hierarchy h = d.AttributeHierarchies.Find("Gender");
                Level l=conn.Cubes["Adventure Works"]
                            .Dimensions["Customer"]
                            .AttributeHierarchies["Customer"]
                            .Levels["Customer"];

                foreach (LevelProperty p in l.LevelProperties)
                {
                    Console.WriteLine(p.UniqueName);
                }

                MemberFilter[] mf=new MemberFilter[2]; 
                   mf[0] =new MemberFilter("Gender",MemberFilterType.Equals,"Female");
                   mf[1]= new MemberFilter("Name",MemberFilterType.Contains,"Maria");
                string[] ElementEigenschaften =new string[1];
                ElementEigenschaften[0] = "[Customer].[Customer].[Customer].[Gender]";
                MemberCollection mc = l.GetMembers(0, l.MemberCount, ElementEigenschaften, mf);
                foreach (Member m in mc)
                {
                    Console.WriteLine(m.Name);
                }
                
            }

            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            finally
            {
                if (conn.State == System.Data.ConnectionState.Open)
                {
                    conn.Close();
                }
            }
            Console.ReadLine();
        }

    }

}
