using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices;
namespace AMO_Roles
{
    class AMO_Roles
    {
        static void Main(string[] args)
        {
                         Server serv = new Server();
            serv.Connect("local");
            if (serv.Connected)
            {

                leserRolle(serv);
            }
            
        }
        static void leserRolle(Server serv)
        {
            Database dbs = serv.Databases.FindByName("Adventure Works DW 2008 SE");
            if (dbs.Roles.FindByName("Leser") != null)
            {
                dbs.Roles.FindByName("Leser").Drop(DropOptions.AlterOrDeleteDependents);
            }

            //Rolle anlegen
            Role leser = dbs.Roles.Add("Leser", "Leser");
            leser.Update();

            //Datenbankberechtigungen setzen
            DatabasePermission dbsPerm = dbs.DatabasePermissions.Add(leser.ID);
            dbsPerm.Read = ReadAccess.Allowed;
            dbsPerm.Update();

            //Dimensionsberechtigung setzen und das Attribut Calendar Year auf 2004 einschrnken  
            Dimension Dim = dbs.Dimensions.FindByName("Date");
            DimensionPermission dimPerm = Dim.DimensionPermissions.Add(leser.ID);
            DimensionAttribute attr = Dim.Attributes.FindByName("Calendar Year");
            AttributePermission attrPerm = dimPerm.AttributePermissions.Add(attr.ID);
            attrPerm.AllowedSet = "{[Date].[Calendar Year].&[2004]}";
            dimPerm.Update();

            //Cube berechtgung setzen
            Cube cub = dbs.Cubes.FindByName("Adventure Works");
            CubePermission cubPerm = cub.CubePermissions.Add(leser.ID);
            cubPerm.Read = ReadAccess.Allowed;
            cubPerm.Update();

            //User anfgen
            leser.Members.Add(new RoleMember("testuser"));
            leser.Update();

        }
    }
}
