using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices;
using Microsoft.AnalysisServices.AdomdClient;
using System.IO;

namespace AMO_Trace
{
    class AMO_Trace
    {
        static void Main(string[] args)
        {
 Server serv = new Server();
            serv.Connect("local");
            if (serv.Connected)
            {
                string traceDir = "C:/Trace";
                if (!Directory.Exists(traceDir))
                    Directory.CreateDirectory(traceDir);

                ServerTrace(serv);
                Console.WriteLine("Zum Starten des Session Traces besttigen Sie mit ENTER");
                Console.ReadLine();
                SessionTrace(serv);
            }

        }
        static public void ServerTrace(Server serv)
        {
                if (serv.Traces.FindByName("myTrace") != null)
                {
                    serv.Traces.FindByName("myTrace").Drop();
                }
                Trace tc = serv.Traces.Add("myTrace");
                tc.AutoRestart = false;
                tc.LogFileName = "C:/Trace/myTrace.trc";
                tc.LogFileSize = 20;//Megabyte
                tc.LogFileRollover = true;
                //Ereignisse bestimmen, die aufgezeichnet werden sollen              
                TraceEvent te = tc.Events.Add(TraceEventClass.ProgressReportBegin);
                //Spalten auswhlen, die das TraceEventObjekt in die Trace Datei schreibt
                te.Columns.Add(TraceColumn.TextData);
                te.Columns.Add(TraceColumn.NTCanonicalUserName);
                te.Columns.Add(TraceColumn.StartTime);
                te.Columns.Add(TraceColumn.EventSubclass);
                //Trace erstellen und starten
                tc.Update();
                tc.Start();
                Console.WriteLine("Tracen gestartet");
                //Eine Datenbank erstellen
                serv.Databases.FindByName("Adventure Works DW 2008 SE").Process();
                Console.WriteLine("Adventure Works DW erstellt");
                //Trace stoppen und lschen
                tc.Stop();
                tc.Drop();
                Console.WriteLine("Tracen beendet");
        }
        static public void SessionTrace(Server serv)
        {
            serv.SessionTrace.OnEvent+=new TraceEventHandler(SessionTrace_OnEvent);
            serv.SessionTrace.Start();
            //serv.Databases.FindByName("NewDB").Process();
            AdomdConnection conn = new AdomdConnection();
            conn.ConnectionString = "Data Source=local;Catalog='Adventure Works DW 2008 SE';SessionID=" + serv.SessionID;
            conn.Open();
            AdomdCommand cmd = conn.CreateCommand();
            cmd.CommandText = "SELECT [Product].[Color].members on 0 FROM [Adventure Works]";
            System.Xml.XmlReader xreader = cmd.ExecuteXmlReader();
            Console.WriteLine(xreader.ReadInnerXml());
            xreader.Close();
            conn.Close();
            serv.SessionTrace.Stop();
            Console.ReadLine();
        }

        static public void SessionTrace_OnEvent(object o, TraceEventArgs tea)
        {
            Console.WriteLine("Sessiontrace:  "+tea.TextData);
        }
    }
}
