﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SSRS;

public partial class _Default : System.Web.UI.Page 
{

    ReportingService2005 rs;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            rs = new ReportingService2005();
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            lbl_RS_ServerUrl.Text = rs.Url;
            get_RS_Folders();
        }
    }
    private void get_RS_Folders()
    {
        CatalogItem[] items = null;
        items = rs.ListChildren("/",true);
        TreeNode root = new TreeNode("Berichtsserver Ordner");
        root.Value = "/";
        RS_FolderTree.Nodes.Add(root);
        foreach (CatalogItem item in items)
        {
            String it = item.Type.ToString();
            if (it == "Folder" | it == "Report")
            {
                TreeNode tn = new TreeNode(item.Name);
                tn.Value = item.Path.ToString() + "/";
                string ParentNodeValue = item.Path.ToString().Replace(item.Name.ToString(), "");
                this.addTreeNode(ParentNodeValue, tn, root);
            }
        }
    }
    private void addTreeNode(String pn_String, TreeNode cn, TreeNode sn)
    {
        if (sn.Value.ToString() == pn_String)
        {
            sn.ChildNodes.Add(cn);
        }
        TreeNodeCollection tnc = sn.ChildNodes;
        foreach (TreeNode tn in tnc)
        {
            if (tn.Value.ToString() == pn_String)
            {
                tn.ChildNodes.Add(cn);
            }
            else
            {
                if (tn.ChildNodes.Count > 0)
                {
                    addTreeNode(pn_String, cn, tn);
                }
            }
        }
    }


    protected void RS_FolderTree_SelectedNodeChanged(object sender, EventArgs e)
    {

        String klickedNodeTarget = RS_FolderTree.SelectedNode.Value.ToString();
        int i = klickedNodeTarget.Length;
        String rp = klickedNodeTarget.Substring(1, i - 2);
        txt_ReportPath.Text = "/" + rp;
        ReportViewer.ServerReport.ReportPath = txt_ReportPath.Text;
    }
}
